<?php

/*
 * This file is part of the Symfony package.
 *
 * (c) Fabien Potencier <fabien@symfony.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace Freefactu_Vendor\Symfony\Component\Validator\Constraints;

use Freefactu_Vendor\Symfony\Component\ExpressionLanguage\ExpressionLanguage;
use Freefactu_Vendor\Symfony\Component\Validator\Constraint;
use Freefactu_Vendor\Symfony\Component\Validator\ConstraintValidator;
use Freefactu_Vendor\Symfony\Component\Validator\Exception\LogicException;
use Freefactu_Vendor\Symfony\Component\Validator\Exception\UnexpectedTypeException;
final class WhenValidator extends ConstraintValidator
{
    public function __construct(private ?ExpressionLanguage $expressionLanguage = null)
    {
    }
    public function validate(mixed $value, Constraint $constraint): void
    {
        if (!$constraint instanceof When) {
            throw new UnexpectedTypeException($constraint, When::class);
        }
        $context = $this->context;
        $variables = $constraint->values;
        $variables['value'] = $value;
        $variables['this'] = $context->getObject();
        $variables['context'] = $context;
        if ($constraint->expression instanceof \Closure) {
            $result = ($constraint->expression)($context->getObject());
        } else {
            $result = $this->getExpressionLanguage()->evaluate($constraint->expression, $variables);
        }
        if ($result) {
            $context->getValidator()->inContext($context)->validate($value, $constraint->constraints);
        } elseif ($constraint->otherwise) {
            $context->getValidator()->inContext($context)->validate($value, $constraint->otherwise);
        }
    }
    private function getExpressionLanguage(): ExpressionLanguage
    {
        if (!class_exists(ExpressionLanguage::class)) {
            throw new LogicException(\sprintf('The "symfony/expression-language" component is required to use the "%s" validator. Try running "composer require symfony/expression-language".', __CLASS__));
        }
        return $this->expressionLanguage ??= new ExpressionLanguage();
    }
}
